<?php

/**
 * This project has been generated by worker generator
 * has been made by fahmi sulaiman
 * sulaimanfahmi@gmail.com
 * check out my github @dekaulitz
 */

namespace App\Http\Models;

use Carbon\Carbon;
use App\Http\Base\BaseModel;

class AdministratormenuModel extends BaseModel
{
    /**
     * table name from database
     */
    protected $table = "administratormenu";

    /**
     *   alias table for relation issues
     */
    protected $aliasTable = "administratormenu";

    /**
     * primary key from table remember eloquent doesnt support composite primary key
     */
    protected $primaryKey = "id";
    /**
     * fillable property for eloquent attribute cast
     */
    protected $fillable = [
        "id", "menuname", "url", "parentmenu", "icon", "description", "position", "date_updated"
    ];
    /**
     * Creating raw object from table that, this purpose for making you easier for remembering all attribute
     */


    /**
     * paging for default paging purpose
     * if you want to add new paging property you have to add the property in this array
     * you have to add the relation value
     * remember this is not suported casting value you have to handle by your self
     */
    protected $aliasPaging = [
        "id" => "administratormenu.id",
        "menuname" => "administratormenu.menuname",
        "url" => "administratormenu.url",
        "parentmenu" => "administratormenu.parentmenu",
        "icon" => "administratormenu.icon",
        "description" => "administratormenu.description",
        "position" => "administratormenu.position",
    ];

    public static function storeFromHO($data)
    {
        $model = (new self())->getQuery()->where("administratormenu.id", "=", $data->id)->first();
        if ($model) {
            $model = self::find($model->id);
            $model->id = $data->id;
            $model->menuname = $data->menuname;
            $model->url = $data->url;
            $model->parentmenu = $data->parentmenu;
            $model->icon = $data->icon;
            $model->description = $data->description;
            $model->position = $data->position;
            $model->active = $data->active;
            $model->update();
            (new LogsynckapalModel)->setLogSync("Menu: ".$data->id." - ".$data->menuname, Carbon::now()->toDateTimeString(), "", "updated");
        } else {
            $model = new self();
            $model->id = $data->id;
            $model->menuname = $data->menuname;
            $model->url = $data->url;
            $model->parentmenu = $data->parentmenu;
            $model->icon = $data->icon;
            $model->description = $data->description;
            $model->position = $data->position;
            $model->active = $data->active;
            $model->save([], $data->id, 0);
            (new LogsynckapalModel)->setLogSync("Menu: ".$data->id." - ".$data->menuname, Carbon::now()->toDateTimeString(), "", "inserted");
        }
        echo $data->menuname . " sync", PHP_EOL;
    }

    public static function getMenu()
    {
        $url = $GLOBALS["env"]["HEAD_OFFICE_URL"] . "/api/sync_menu";
        $syncTable = (new \App\Http\Models\SyncUtilities\SyncTableHandlerModel())->getQuery()->where("sync_table.id", "=", 5)->first();
        $fetch = true;
        $page = 1;
        (new LogsynckapalModel)->setLogSync("Menu HO to Kapal", Carbon::now()->toDateTimeString(), "", "start");
        do {
            if ($syncTable) {

                $syncHandler = new \App\Http\Handler\CurlHandler();
                $lastUpdate = Carbon::parse($syncTable->last_sync)->toAtomString();
                $url = $url . "?date_updated=" . $lastUpdate . "&page=" . $page;
                try {
                    $response = $syncHandler->setUrl($url)->send();
                    $res = json_decode($response, false);
                    $no = 1;
                    if (!empty($res->data)) {
                        foreach ($res->data as $item) {
                            echo "data " . $no;
                            \App\Http\Models\AdministratormenuModel::storeFromHO($item);
                            $lastUpdate = $item->date_updated;
                            $no = $no + 1;
                        }
                    } else { $fetch = false; }
                    $sync = \App\Http\Models\SyncUtilities\SyncTableHandlerModel::find($syncTable->id);
                    $sync->last_sync = $lastUpdate;
                    $sync->update();
                } catch (Exception $e) {
                    echo $e->getMessage();
                    (new LogsynckapalModel)->setLogSync("Menu HO to Kapal", Carbon::now()->toDateTimeString(), $e->getMessage(), "failed");
                }
                $page = $page + 1;
            } else {
                $fetch = false;
            }
        } while ($fetch);
        (new LogsynckapalModel)->setLogSync("Menu HO to Kapal", Carbon::now()->toDateTimeString(), "", "success");
    }
}